import pandas as pd


def import_scans(spreadsheet):
    # Read the values from the excel spreadsheet

    scans = spreadsheet
    scan_data = pd.read_excel(scans, sheet_name="Sheet1")
    names_raw = pd.DataFrame(scan_data, columns=["Name"])
    code_raw = pd.DataFrame(scan_data, columns=["Kantech Codes"])

    names = []
    codes = []
    missing = []

    for n, c in zip(names_raw.values, code_raw.values):
        n = str(n)
        c = str(c)
        n = n.strip("'[]")
        c = c.strip("'[]")
        if n != "nan" and c != "nan":
            names.append(n)
            codes.append(c)
        else:
            if n not in missing:
                missing.append(n)

    return names, codes, missing


def decode_card(code):
    split_code = code.split(":")

    first_hex = split_code[0]
    second_dec = int(split_code[1])

    first_bin = bin(int(first_hex, 16)).zfill(8)
    str_first_bin = str(first_bin).replace("b", "")
    while len(str_first_bin) < 8:
        str_first_bin = "0" + str_first_bin

    second_bin = bin(second_dec).replace("b", "")
    str_second_bin = str(second_bin)
    while len(str_second_bin) < 16:
        str_second_bin = "0" + str_second_bin

    bin_without_parity = str_first_bin + str_second_bin
    print("first bin" , str_first_bin)
    print("2nd bin" , str_second_bin)
    print("right parity" , bin_without_parity[0:12])
    print("left parity" , bin_without_parity[12:24])
    # print("bin without parity" , bin_without_parity)
    left_bin = bin_without_parity[0:12]
    right_bin = bin_without_parity[12:24]
    count_1_left = (str(left_bin)).count("1")
    count_1_right = (str(right_bin)).count("1")



    if count_1_left % 2 == 0:
        left_bit = 0
    else:
        left_bit = 1

    if count_1_right % 2 == 0:
        right_bit = 1
    else:
        right_bit = 0


    bin_string = str(left_bit) + bin_without_parity + str(right_bit)
    hex_string = "{0:0>4X}".format(int(bin_string, 2))
    while len(hex_string) < 7:
        hex_string = "0" + hex_string


    print("Left\n" + str(left_bit) )
    print("Right\n" + str(right_bit))

    print("Hex string\n" + hex_string)
    # print("Bin string\n" + bin_string)
    return hex_string


def main():
    sheet_path = r"C:\Users\cameron\Documents\HID\Xerox Codes - Input.xlsx"
    final_hid_path = r"C:\Users\cameron\Documents\HID\Xerox Codes - Final.csv"
    didnt_process_path = r"C:\Users\cameron\PycharmProjects\HID Converter\People who didn't have codes.csv"

    names, codes, missing = import_scans(sheet_path)

    final_names = []
    final_codes = []
    new_codes = []

    for n, c in zip(names, codes):
        if n not in final_names:
            final_names.append(n)
            final_codes.append(c)
            new_codes.append(decode_card(c))

    # todo
    # Test string
    # Doesn't contain Millennium, Kitchen, Forgot, Champion, SPARE, spare, Auditor, Fireman, Data-4, RPI, TRAINING
    # If contains Energi ot Shell, move to a csv named (manual_rfid.csv)
    # If contains "_", trim the _ and any succeeding characters
    # If contains "(" and ")", trim just those letters.
    #

    final_hid_codes = {"Name": final_names, "Xerox Codes": new_codes }
    didnt_process = {"Name": missing}

    final_hid_df = pd.DataFrame(final_hid_codes, columns=["Name", "Kantech Codes", "Xerox Codes"])
    didnt_process_df = pd.DataFrame(didnt_process, columns=["Name"])

    final_hid_df.to_csv(final_hid_path, index=None, header=True)
    didnt_process_df.to_csv(didnt_process_path, index=None, header=True)

    # ids = ["0B:30450", "0B:17085", "0B:32261"]
    # """
    # 042CEDE5
    # 002C857A
    # 002CFC0B
    # """
    # for card in ids:
    #     decode_card(card)

if __name__ == "__main__":
    main()

